import sys
import time
import binascii

import tb as traceback
import javascript

from browser import document as doc, window, alert, bind, html


def run(code, element, turtle_div, *args):
    
    if turtle_div:
        window.turtle_div = turtle_div
        
    cOut = cOutput(element)
    sys.stdout = cOut
    sys.stderr = cOut
        
    try:
        ns = {'__name__':'__main__'}
        exec(code, ns)
        state = 1
    except Exception as exc:
        traceback.print_exc(file=sys.stderr)
        state = 0
    sys.stdout.flush()
    return state

class cOutput:
    encoding = 'utf-8'
    def __init__(self, console):
        self.cons = console
        self.cons.textContent = ''
        self.buf = ''

    def write(self, data):
        self.buf += str(data)

    def flush(self):
        self.cons.textContent += self.buf
        self.buf = ''

    def __len__(self):
        return len(self.buf)

print('run', run)
window.run = run